#!/usr/bin/env node
import h from "prompts";
import { join as u, basename as D } from "node:path";
import { existsSync as l, readFileSync as P, mkdirSync as E, writeFileSync as i, appendFileSync as w, rmSync as x, statSync as C, readdirSync as V } from "node:fs";
import c from "chalk";
import v from "lodash.upperfirst";
import S from "lodash.camelcase";
import T from "lodash.kebabcase";
import A from "lodash.template";
import _ from "lodash.get";
import $ from "lodash.lowerfirst";
import b from "json5";
import { resolveTemplate as N } from "./template.js";
import { rootPath as F, configPath as R } from "./path.config.js";
const k = () => {
  let n;
  const r = u(F, R);
  if (l(r)) {
    const o = P(r, "utf-8");
    n = b.parse(o);
  }
  if (!n)
    throw new Error("配置文件不存在");
  return n;
}, j = async (n) => {
  const r = (n == null ? void 0 : n.series) || (await h({
    type: "text",
    name: "series",
    message: "请输入组件系列前缀",
    validate: (o) => o ? !0 : "组件系列前缀不能为空"
  })).series;
  if (!r)
    throw new Error("组件系列前缀不能为空");
  return r;
}, I = async (n) => {
  const r = (n == null ? void 0 : n.src) || (await h({
    type: "text",
    name: "src",
    message: "请输入组件源码路径",
    initial: "src",
    validate: (o) => o ? !0 : "组件源码路径不能为空"
  })).src;
  if (!r)
    throw new Error("组件源码路径不能为空");
  return r;
}, L = ({
  src: n,
  entryAbsoluteSrc: r,
  entryTemplate: o
}) => {
  const a = u(F, n), m = C(a);
  let e = "";
  if (l(r) && (e = P(r, "utf-8") || ""), !e)
    throw new Error("没有可以删除的文件");
  if (m.isDirectory()) {
    const p = V(a), t = A(o), d = p.map((f) => {
      const y = u(a, f);
      return C(y).isDirectory() ? D(y) : "";
    }).filter((f) => {
      if (!f)
        return !1;
      const y = g({ name: f }), s = t({
        ...y,
        src: n,
        nameLowerFirst: $(y.name)
      });
      return e.includes(s);
    });
    if (d.length === 0)
      throw new Error("组件列表为空");
    return d;
  } else
    throw new Error("组件源码路径不是目录");
}, g = ({
  name: n,
  series: r
}) => {
  const o = v(S(n)), a = r ? v(S(r)) : "", m = r ? `${a}${o}` : "", e = r ? T(m) : "", p = T(n);
  return {
    series: a,
    name: o,
    full: m,
    cls: e,
    dir: p
  };
}, q = async ({
  argv: n,
  configInfo: r
}) => {
  const o = await j(r), a = n.name || (await h({
    type: "text",
    name: "name",
    message: "请输入组件名称",
    validate: (p) => p ? !0 : "组件名称不能为空"
  })).name;
  if (!a)
    throw new Error("组件名称不能为空");
  const m = g({
    name: a,
    series: o
  });
  console.log(m);
  const e = N(
    r,
    {
      ...m,
      rootPath: F
    },
    [
      "component.dir",
      "component.templateFilePath",
      "component.fileName",
      "component.entryTemplate",
      "component.entryPath",
      "style.dir",
      "style.templateFilePath",
      "style.fileName",
      "style.varTemplate",
      "style.varPath",
      "style.entryTemplate",
      "style.entryPath",
      "example.dir",
      "example.templateFilePath",
      "example.fileName",
      "example.entryTemplate",
      "example.entryPath"
    ]
  );
  if (console.log(e), l(e.componentFilePath))
    throw new Error("组件已存在");
  if (l(e.styleFilePath))
    throw new Error("样式已存在");
  if (l(e.exampleFilePath))
    throw new Error("示例已存在");
  E(e.componentDirPath, { recursive: !0 }), i(e.componentFilePath, e.componentFileContent), E(e.styleDirPath, { recursive: !0 }), i(e.styleFilePath, e.styleFileContent), E(e.exampleDirPath, { recursive: !0 }), i(e.exampleFilePath, e.exampleFileContent), l(e.componentEntryFilePath) || i(e.componentEntryFilePath, ""), w(
    e.componentEntryFilePath,
    e.componentEntryFileAddContent
  ), l(e.styleEntryFilePath) || i(e.styleEntryFilePath, ""), w(e.styleEntryFilePath, e.styleEntryFileAddContent), l(e.styleVarFilePath) || i(e.styleVarFilePath, ""), w(e.styleVarFilePath, e.styleVarFileAddContent), l(e.exampleEntryFilePath) || i(e.exampleEntryFilePath, ""), w(e.exampleEntryFilePath, e.exampleEntryFileAddContent), console.log(c.green("创建成功"));
}, z = async ({
  configInfo: n,
  src: r
}) => {
  const o = _(n, "component.entryPath"), a = A(o)({
    src: r
  }), m = L({
    src: r,
    entryAbsoluteSrc: u(F, a),
    entryTemplate: n.component.entryTemplate
  }).map((s) => ({ title: s, value: s })), { name: e } = await h({
    type: "select",
    name: "name",
    message: "请选择要删除的组件",
    choices: m
  });
  if (console.log("name:", e), !e)
    throw new Error("组件名称不能为空");
  const p = g({
    name: e
  });
  console.log(p);
  const t = N(
    n,
    {
      ...p,
      rootPath: F
    },
    [
      "component.dir",
      "component.templateFilePath",
      "component.fileName",
      "component.entryTemplate",
      "component.entryPath",
      "style.dir",
      "style.templateFilePath",
      "style.fileName",
      "style.varTemplate",
      "style.varPath",
      "style.entryTemplate",
      "style.entryPath",
      "example.dir",
      "example.templateFilePath",
      "example.fileName",
      "example.entryTemplate",
      "example.entryPath"
    ]
  );
  console.log(t), l(t.componentFilePath) || console.log(c.red("组件不存在")), l(t.styleFilePath) || console.log(c.red("样式不存在")), l(t.exampleFilePath) || console.log(c.red("示例不存在"));
  const { delComponent: d } = await h({
    type: "confirm",
    name: "delComponent",
    message: `确认删除${t.componentDirPath}吗`
  });
  if (!d)
    throw new Error("取消删除");
  const { delStyle: f } = await h({
    type: "confirm",
    name: "delStyle",
    message: `确认删除${t.styleFilePath}吗`
  });
  if (!f)
    throw new Error("取消删除");
  const { delExample: y } = await h({
    type: "confirm",
    name: "delExample",
    message: `确认删除${t.exampleDirPath}吗`
  });
  if (!y)
    throw new Error("取消删除");
  if (x(t.componentDirPath, { recursive: !0, force: !0 }), x(t.styleFilePath), x(t.exampleDirPath, { recursive: !0, force: !0 }), !l(t.componentEntryFilePath))
    console.log(c.red("组件入口不存在"));
  else {
    const s = P(t.componentEntryFilePath, "utf-8");
    i(
      t.componentEntryFilePath,
      s.replace(t.componentEntryFileAddContent, "")
    );
  }
  if (!l(t.styleEntryFilePath))
    console.log(c.red("样式入口不存在"));
  else {
    const s = P(t.styleEntryFilePath, "utf-8");
    i(
      t.styleEntryFilePath,
      s.replace(t.styleEntryFileAddContent, "")
    );
  }
  if (!l(t.styleVarFilePath))
    console.log(c.red("样式变量不存在"));
  else {
    const s = P(t.styleVarFilePath, "utf-8");
    i(
      t.styleVarFilePath,
      s.replace(t.styleVarFileAddContent, "")
    );
  }
  if (!l(t.exampleEntryFilePath))
    console.log(c.red("示例入口不存在"));
  else {
    const s = P(t.exampleEntryFilePath, "utf-8");
    i(
      t.exampleEntryFilePath,
      s.replace(t.exampleEntryFileAddContent, "")
    );
  }
  console.log(c.green("删除成功"));
}, ee = async (n, r) => {
  const o = k(), a = await I(o);
  if (n === "add")
    await q({ argv: r, configInfo: o, src: a });
  else if (n === "remove")
    await z({ argv: r, configInfo: o, src: a });
  else
    throw new Error(`未知命令${n}`);
};
export {
  q as dealAdd,
  z as dealRemove,
  g as getAllNameInfo,
  ee as handler
};
